#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_DragonPalace.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_DragonPalace> Fish_DragonPalace::msSingleton(nullptr);

int Fish_DragonPalace::GetCount()
{
	return (int)mMapData.size();
}

const Fish_DragonPalaceData* Fish_DragonPalace::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_DragonPalaceData>& Fish_DragonPalace::GetMapData()
{
	return mMapData;
}

void Fish_DragonPalace::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_DragonPalace::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_DragonPalaceData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mIcon = element->Attribute("Icon");
		data.mString1 = element->Attribute("String1");
		{
			const char* String2 = element->Attribute("String2");
			std::vector<std::string> vecString2;
			boost::split(vecString2, String2, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecString2.size(); i++)
			{
				data.mString2.push_back(vecString2[i]);
			}
		}
		{
			const char* String3 = element->Attribute("String3");
			std::vector<std::string> vecString3;
			boost::split(vecString3, String3, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecString3.size(); i++)
			{
				data.mString3.push_back(vecString3[i]);
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_DragonPalace::Load()
{
	Load("../Config/Fish_DragonPalace.xml");
}

Fish_DragonPalace* Fish_DragonPalace::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_DragonPalace());
	}
	return msSingleton.get();
}
